package com.example.barcode2ds;

import java.io.UnsupportedEncodingException;

import com.example.barcode2ds.SoundManage.SoundType;
import com.zebra.adc.decoder.Barcode2DWithSoft;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.pm.PackageManager;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {
	public Barcode2DWithSoft mReader;
	Button btn;
	TextView tv;
	String seldata = "ASCII";
	private ArrayAdapter adapterTagType;
	private Spinner spTagType;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		try {
			mReader = Barcode2DWithSoft.getInstance();
		} catch (Exception ex) {

			Toast.makeText(MainActivity.this, ex.getMessage(),
					Toast.LENGTH_SHORT).show();

			return;
		}

		btn = (Button) findViewById(R.id.button1);
		tv = (TextView) findViewById(R.id.textView1);

		spTagType = (Spinner) findViewById(R.id.spTagType);
		adapterTagType = ArrayAdapter.createFromResource(this,
				R.array.arrayTagType, android.R.layout.simple_spinner_item);

		adapterTagType
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

		spTagType.setAdapter(adapterTagType);
		spTagType.setSelection(1);

		spTagType
				.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

					@Override
					public void onItemSelected(AdapterView<?> adapterView,
							View view, int position, long id) {
						// ȡѡֵ
						Spinner spinner = (Spinner) adapterView;
						seldata = (String) spinner.getItemAtPosition(position);
					}

					@Override
					public void onNothingSelected(AdapterView<?> arg0) {
						// TODO Auto-generated method stub

					}
				});

		btn.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				tv.setText("");
				mReader.scan();
				mReader.setScanCallback(mScanCallback);

			}
		});

		new InitTask().execute();
	}

	public Barcode2DWithSoft.ScanCallback mScanCallback = new Barcode2DWithSoft.ScanCallback() {
		@Override
		public void onScanComplete(int i, int length, byte[] data) {

			Log.i("ErDSoftScanFragment", "onScanComplete() i=" + i);

			if (length < 1) {

				return;
			}

			String barCode = "";
			try {
				barCode = new String(data, 0, length, seldata);
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (!barCode.isEmpty()) {
				SoundManage.PlaySound(MainActivity.this, SoundType.SUCCESS);
			}
			tv.setText(barCode);

		}
	};

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {

		if (keyCode == 139 || keyCode == 280) {

			if (event.getRepeatCount() == 0) {
				tv.setText("");
				mReader.scan();
				mReader.setScanCallback(mScanCallback);
			}
		}

		return super.onKeyDown(keyCode, event);
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();

		/*
		 * if (mReader != null) { mReader.close(); }
		 */
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();

		/*
		 * if (mReader != null) { new InitTask().execute(); }
		 */
	}

	@Override
	protected void onDestroy() {
		if (mReader != null) {
			mReader.close();
		}
		super.onDestroy();
	}

	/**
	 * 豸ϵ첽
	 * 
	 * @author
	 */
	public class InitTask extends AsyncTask<String, Integer, Boolean> {
		ProgressDialog mypDialog;

		@Override
		protected Boolean doInBackground(String... params) {

			boolean result = false;

			if (mReader != null) {
				result = mReader.open(MainActivity.this);

				if (result) {
					/*
					 * mReader.setParameter(324, 1); mReader.setParameter(300,
					 * 0); // Snapshot Aiming mReader.setParameter(361, 0); //
					 * Image Capture Illumination
					 */
					mReader.setScanCallback(mScanCallback);
				}
			}

			return result;
		}

		@Override
		protected void onPostExecute(Boolean result) {
			super.onPostExecute(result);

			mypDialog.cancel();

			if (!result) {

				Toast.makeText(MainActivity.this, "init fail",
						Toast.LENGTH_SHORT).show();
			}
		}

		@Override
		protected void onPreExecute() {
			// TODO Auto-generated method stub
			super.onPreExecute();

			mypDialog = new ProgressDialog(MainActivity.this);
			mypDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
			mypDialog.setMessage("init...");
			mypDialog.setCanceledOnTouchOutside(false);
			mypDialog.show();
		}

	}
}
